package cz.jzitnik.game.items;

import cz.jzitnik.game.Block;
import cz.jzitnik.game.SpriteLoader;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Optional;

@Getter
@AllArgsConstructor
public class Item {
    private String id;
    private String name;
    private ItemType type;
    private Optional<ToolVariant> toolVariant = Optional.empty();
    private SpriteLoader.SPRITES sprite;
    private boolean stackable = true;
    private int durability;
    private int miningDecrease = 0;
    private int stackAmount = 64;
    private Optional<Block> block;

    public Item(String id, String name, ItemType type, SpriteLoader.SPRITES sprite, Block block) {
        this.id = id;
        this.name = name;
        this.type = type;
        this.sprite = sprite;
        this.block = Optional.of(block);
    }

    public void use() {
        durability--;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Item item = (Item) o;

        return name.equals(item.name);
    }
}
