package cz.jzitnik.game.ui;

import cz.jzitnik.game.Generation;
import cz.jzitnik.game.SpriteLoader;
import cz.jzitnik.game.items.InventoryItem;
import cz.jzitnik.game.items.Item;
import cz.jzitnik.game.items.ItemBlockGenerator;
import cz.jzitnik.game.items.ItemType;
import cz.jzitnik.tui.SpriteList;
import lombok.Getter;

import java.util.List;
import java.util.Optional;

public class SmallCraftingTable {
    public static final int ROW_AMOUNT = 2;
    public static final int COLUMN_AMOUNT = 2;

    private Inventory inventory;
    @Getter
    private InventoryItem[] items = new InventoryItem[4];

    public void click(int x, int y) {
        if (x > 106) {
            if (y > 10 && y < 37) {
                // Pickup item from crafting table

                return;
            }

            return;
        }

        int blockX = x / 53;
        int blockY = y / 26;

        int blockIndex = blockY * COLUMN_AMOUNT + blockX;

        if (items[blockIndex] == null && inventory.getSelectedItemInv() != -1) {
            items[blockIndex] = inventory.getSelectedItem();
        } else if (items[blockIndex] != null) {
            inventory.setSelectedItemInv(blockIndex + 29);
        }
    }

    public StringBuilder render(SpriteList spriteList) {
        var buf = new StringBuilder();

        List<String> sprites = inventory.getSprites(items, spriteList, inventory.getSelectedItemInv() - 29);

        Optional<Item> craftedItem = Optional.of(ItemBlockGenerator.Items.dirt());

        String[] craftedSprite = craftedItem.isPresent() ? spriteList.getSprite(craftedItem.get().getSprite()).getSprite().split("\n") : null;

        int counter = 0;
        for (int i = 0; i < ROW_AMOUNT; i++) {
            for (int j = 0; j < 26; j++) {
                if (j == 25) {
                    buf.append("\033[38;5;231;48;5;231m▓".repeat(106));
                } else {
                    for (int k = 0; k < COLUMN_AMOUNT; k++) {
                        buf.append("\033[38;5;231;48;5;231m▓".repeat(2));
                        String sprite = sprites.get(i * 2 + k);
                        if (sprite == null) {
                            buf.append("\033[0m ".repeat(50));
                        } else {
                            String[] spriteLines = sprite.split("\n");
                            buf.append(spriteLines[j]);
                        }
                    }
                    buf.append("\033[38;5;231;48;5;231m▓".repeat(2));
                }

                if (i == 0 && j > 10 || i == 1 && j < 12)  {
                    buf.append("\033[0m").append(" ".repeat(7));
                    if (i == 0 && j - 11 == 0 || i == 1 && j == 11) {
                        buf.append("\033[38;5;231;48;5;231m▓".repeat(54));
                    } else {
                        buf.append("\033[38;5;231;48;5;231m▓".repeat(2));
                        if (craftedItem.isEmpty()) {
                            buf.append("\033[0m ".repeat(50));
                        } else {
                            buf.append(craftedSprite[counter]);
                            counter++;
                        }
                        buf.append("\033[38;5;231;48;5;231m▓".repeat(2));
                    }
                }

                buf.append("\n");
            }
        }

        buf.append("\033[0m");

        return buf;
    }

    public SmallCraftingTable(Inventory inventory) {
        this.inventory = inventory;
    }
}
